/*
 * This file is part of XViewdata - a viewdata terminal emulator.
 * Copyright (C) 1997 Peter Corlett. All Rights Reserved.
 *
 * TerminalDriver.cc - Implementation of a generic terminal driver
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "../config.h"

#include <unistd.h>

#include "global.h"
#include "TerminalDriver.h"
#include "Viewdata.h"

struct TerminalDrivers TerminalDrivers[] = {
  {"viewdata", (TerminalDriver *(*)(const String &))newViewdata},
  {NULL}
};

void TerminalDriver::clear() {
  POFUNC;
}

void TerminalDriver::free() {
  POFUNC;
  clear();
}

TerminalDriver::TerminalDriver(void) {
  POFUNC;
  clear();
}

TerminalDriver::~TerminalDriver() {
  POFUNC;
  free();
}

TerminalDriver *newTerminalDriver(const String &dn, const String &da) return d {
  PGFUNC;
  D("trying to open \"" << dn << ":" << da);
  d=NULL;

  for(int n=0;TerminalDrivers[n].name&&!d;n++)
    if(!fcompare(dn, TerminalDrivers[n].name))
      if(TerminalDrivers[n].newobject) {
	d=(*TerminalDrivers[n].newobject)(da);
      }

  if(!d)
    return;
}

