/*
 * This file is part of XViewdata - a viewdata terminal emulator.
 * Copyright (C) 1997 Peter Corlett. All Rights Reserved.
 *
 * Viewdata.h - prototypes for Viewdata terminal driver
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#ifndef VIEWDATA_H
#define VIEWDATA_H

#include "TerminalDriver.h"

/// Provides Viewdata terminal emulation
class Viewdata : public TerminalDriver {
  UBYTE *vmap; /* viewdata charmap */
//  int cursx, cursy; /* Cursor x,y position */
//  BOOL cursv; /* Cursor visible */
  BOOL escpending; /* Have we just had an escape code? */
  BOOL ctrl_key; /* Control key pressed state, TRUE=pressed */
  void clear(void);
  void free(void);
  int putc(UBYTE c);
  void cls(void);
///
public:
  /// Default constructor.
  Viewdata(void);
  /// Destructor.
  ~Viewdata();

  ///
  friend Viewdata *newViewdata(const String &arg);

  /// (see TerminalDriver)
  int write(const char *buf, int len);
  /// (see TerminalDriver)
  int read(char *buf, int len, int key);
  /// (see TerminalDriver)
  int keyupread(char *buf, int len, int key);

  /// (see TerminalDriver)
  BOOL setSize(int x, int y);
};

#endif /* VIEWDATA_H */
